## org.biojava.bio.gui.sequence
Class FilteringRenderer

    java.lang.Object
      org.biojava.utils.AbstractChangeable
          org.biojava.bio.gui.sequence.SequenceRendererWrapper
              org.biojava.bio.gui.sequence.FilteringRenderer

All Implemented Interfaces:
  Serializable, SequenceRenderer, Changeable

Direct Known Subclasses:
  GlyphFeatureRenderer

    public class FilteringRenderer

extends SequenceRendererWrapper

Author:
  Matthew Pocock, Thomas Down
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from interface org.biojava.bio.gui.sequence.SequenceRenderer
`SequenceRenderer.RendererForwarder`

Field Summary
`protected FeatureFilter` `filter`
`static ChangeType` `FILTER`
`protected boolean` `recurse`
`static ChangeType` `RECURSE`

Fields inherited from class org.biojava.bio.gui.sequence.SequenceRendererWrapper
`RENDERER`

Constructor Summary
`FilteringRenderer()`
`FilteringRenderer(SequenceRenderer renderer, FeatureFilter filter, boolean recurse)`

Method Summary
`protected ChangeSupport` `getChangeSupport(ChangeType ct)` Called to retrieve the ChangeSupport for this object.
`protected SequenceRenderContext` `getContext(SequenceRenderContext src)`
`double` `getDepth(SequenceRenderContext src)` Retrieve the depth of this renderer when rendering src.
`FeatureFilter` `getFilter()`
`double` `getMinimumLeader(SequenceRenderContext src)` Retrieve the minimum leading distance for this renderer when rendering src.
`double` `getMinimumTrailer(SequenceRenderContext src)` Retrieve the minimum trailing distance for this renderer when rendering src.
`boolean` `getRecurse()`
`protected boolean` `hasListeners()` Discover if we have any listeners registered.
`void` `paint(Graphics2D g, SequenceRenderContext src)` Render a portion (possibly all) of the information for src to g, displaying all of the data that would fall within seqBox.
`SequenceViewerEvent` `processMouseEvent(SequenceRenderContext src, MouseEvent me, List path)` Produce a SequenceViewerEvent in response to a mouse gesture.
`void` `setFilter(FeatureFilter filter)`
`void` `setRecurse(boolean recurse)`
`String` `toString()`

Methods inherited from class org.biojava.bio.gui.sequence.SequenceRendererWrapper
`getRenderer, setRenderer`

Methods inherited from class org.biojava.utils.AbstractChangeable
`addChangeListener, addChangeListener, generateChangeSupport, hasListeners, isUnchanging, removeChangeListener, removeChangeListener`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### FILTER

    public static ChangeType FILTER

### RECURSE

    public static ChangeType RECURSE

### filter

    protected FeatureFilter filter

### recurse

    protected boolean recurse

Constructor Detail

### FilteringRenderer

    public FilteringRenderer()

### FilteringRenderer

    public FilteringRenderer(SequenceRenderer renderer,
                             FeatureFilter filter,
                             boolean recurse)

Method Detail

### hasListeners

    protected boolean hasListeners()

  Description copied from class: `AbstractChangeable`
  Discover if we have any listeners registered.

  Overrides:
    `hasListeners` in class `AbstractChangeable`
  Returns:
    true if there is at least one listener

### getChangeSupport

    protected ChangeSupport getChangeSupport(ChangeType ct)

  Description copied from class: `AbstractChangeable`
  Called to retrieve the ChangeSupport for this object.

  Your implementation of this method should have the following structure: ``

       ChangeSupport cs = super.getChangeSupport(ct);

       if(someForwarder == null && ct.isMatching(SomeInterface.SomeChangeType)) {
         someForwarder = new ChangeForwarder(...

         this.stateVariable.addChangeListener(someForwarder, VariableInterface.AChange);
       }

       return cs;

  It is usual for the forwarding listeners (someForwarder in this example) to be transient and lazily instantiated. Be sure to register & unregister the forwarder in the code that does the ChangeEvent handling in setter methods.

  Overrides:
    `getChangeSupport` in class `SequenceRendererWrapper`

### setFilter

    public void setFilter(FeatureFilter filter)
                   throws ChangeVetoException

  Throws:
    `ChangeVetoException`

### getFilter

    public FeatureFilter getFilter()

### setRecurse

    public void setRecurse(boolean recurse)
                    throws ChangeVetoException

  Throws:
    `ChangeVetoException`

### getRecurse

    public boolean getRecurse()

### getDepth

    public double getDepth(SequenceRenderContext src)

  Description copied from interface: `SequenceRenderer`
  Retrieve the depth of this renderer when rendering src.

  The depth may vary between sequence panels - for example based upon sequence length. Each line of information in the SequenceRendererContext only renders a region of the sequence. The depth for one complete line may be different from that for another due to the sequence having more or less information in that region to show. For example, a feature renderer implementation may chose to collapse down to a depth of zero pixels if there are no features to render within a region.

  Specified by:
    `getDepth` in interface `SequenceRenderer`
  Overrides:
    `getDepth` in class `SequenceRendererWrapper`
  Parameters:
    `src` - the SequenceRenderContext to return info for
  Returns:
    the depth of the renderer for that sequence panel

### getMinimumLeader

    public double getMinimumLeader(SequenceRenderContext src)

  Description copied from interface: `SequenceRenderer`
  Retrieve the minimum leading distance for this renderer when rendering src.

  The leading distance may vary between sequence panels - for example based upon sequence length.

  Specified by:
    `getMinimumLeader` in interface `SequenceRenderer`
  Overrides:
    `getMinimumLeader` in class `SequenceRendererWrapper`
  Parameters:
    `src` - the SequenceRenderContext to return info for
  Returns:
    the leading distance of the renderer for that sequence panel

### getMinimumTrailer

    public double getMinimumTrailer(SequenceRenderContext src)

  Description copied from interface: `SequenceRenderer`
  Retrieve the minimum trailing distance for this renderer when rendering src.

  The trailing distance may vary between sequence panels - for example based upon sequence length.

  Specified by:
    `getMinimumTrailer` in interface `SequenceRenderer`
  Overrides:
    `getMinimumTrailer` in class `SequenceRendererWrapper`
  Parameters:
    `src` - the SequenceRenderContext to return info for
  Returns:
    the trailing distance of the renderer for that sequence panel

### paint

    public void paint(Graphics2D g,
                      SequenceRenderContext src)

  Description copied from interface: `SequenceRenderer`
  Render a portion (possibly all) of the information for src to g, displaying all of the data that would fall within seqBox.

  Specified by:
    `paint` in interface `SequenceRenderer`
  Overrides:
    `paint` in class `SequenceRendererWrapper`
  Parameters:
    `g` - the Graphics2D to render to
    `src` - the SequenceRenderContext that encapsulates the information to render

### processMouseEvent

    public SequenceViewerEvent processMouseEvent(SequenceRenderContext src,
                                                 MouseEvent me,
                                                 List path)

  Description copied from interface: `SequenceRenderer`
  Produce a SequenceViewerEvent in response to a mouse gesture.

  A SequenceRenderer that performs any form of coordinate remapping should ensure that it appropriately transforms the mouse event. However, in the SequenceViewerEvent returned, the MouseEvent should be in untransformed coordinates.

  The SequenceRenderer implementation should append itself to the path list before constructing the SequenceViewerEvent.

  Specified by:
    `processMouseEvent` in interface `SequenceRenderer`
  Overrides:
    `processMouseEvent` in class `SequenceRendererWrapper`
  Parameters:
    `src` - the SequenceRenderContext currently in scope
    `me` - a MouseEvent that caused this request
    `path` - the List of SequenceRenderer instances passed through so far
  Returns:
    a SequenceViewerEvent encapsulating the mouse gesture

### getContext

    protected SequenceRenderContext getContext(SequenceRenderContext src)

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`